unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ShellCtrls, StrUtils, Buttons, Registry;

type
  TForm1 = class(TForm)
    ShellTreeView1: TShellTreeView;
    CheckBox1: TCheckBox;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    Edit3: TEdit;
    Button1: TButton;
    GroupBox2: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Button2: TButton;
    GroupBox3: TGroupBox;
    Label7: TLabel;
    Label8: TLabel;
    ListBox1: TListBox;
    Memo1: TMemo;
    SpeedButton1: TSpeedButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    function lDir(dOrigen: string) : String;
    function lFile(dOrigen: string) : String;
    function fInFile(const Fichero: string ;const Cadena: string):integer;
    procedure Button2Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  fList: TStringList;
  dList: TStringList;
  fChange: TStringList;
  sFile: TCustomMemo;
  x: Integer;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
  reg: TRegistry;
  temp: String;
begin
  reg:=TRegistry.Create;
  reg.RootKey:=HKEY_LOCAL_MACHINE;
  reg.OpenKey('SOFTWARE\Buscador',True);
  temp:=reg.ReadString('patron');
  if temp<>'' then
    Edit3.Text := temp
  else
    Edit3.Text := '';
  temp:=reg.ReadString('subdirs');
  if temp='Si' then
    CheckBox1.Checked := True;
  Edit1.Text := '';
  Edit2.Text := '';
  reg.Free;
  fList := TStringList.Create;
  dList := TStringList.Create;
  fChange := TStringList.Create;
  Button2.Enabled := False;
  GroupBox3.Visible := False;
  Label7.Caption := 'Estado: Inactivo...';
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  found: Integer;
  cant: Integer;
  SelPos: Integer;
  doit: Byte;
begin
  Button2.Enabled := False;
  fList.Clear;
  dList.Clear;
  Label7.Caption := 'Estado: Cargando carpetas...';
  lDir(ShellTreeView1.Path+'\');
  Label7.Caption := 'Estado: Cargando ficheros...';
  lFile(ShellTreeView1.Path+'\');
  cant := 0;
  Label7.Caption := 'Estado: Buscando en ficheros...';
  Label6.Caption := 'Ficheros coincidentes: 0';
  Label8.Caption := 'Reemplazos: 0';
  for x := 0 to fList.Count-1 do
    begin
      found := fInFile(fList.Strings[x],Edit1.Text);
      Application.ProcessMessages;
      if found <>-1 then
        begin
          cant := cant+1;
          Label6.Caption := 'Ficheros coincidentes: '+IntTostr(cant);
          fChange.Add(fList.Strings[x]);
        end;
    end;
  if (fChange.Count>0) and (Edit2.Text<>'') then
    begin
      cant := 0;
      sFile := TCustomMemo.Create(Self);
      with sFile do
        begin
          Name := 'sFile';
          Parent := Self;
          Lines.Clear;
        end;
      Label7.Caption := 'Estado: Reemplazando texto...';
      for x := 0 to fChange.Count-1 do
        begin
          sFile.Lines.LoadFromFile(fChange.Strings[x]);
          doit := 0;
          While Pos(Edit1.Text, sFile.Lines.Text)>0 Do
            begin
              SelPos := Pos(Edit1.Text, sFile.Lines.Text);
              if SelPos > 0 then
                begin
                  sFile.SelStart := SelPos - 1;
                  sFile.SelLength := Length(Edit1.Text);
                  sFile.SelText := Edit2.Text;
                  doit := 1;
                  cant := cant+1;
                end;
            end;
          if doit=1 then
            begin
              sFile.Lines.SaveToFile(fChange.Strings[x]);
              Label8.Caption := 'Reemplazos: '+IntTostr(cant);
            end;
          sFile.Clear;
          Application.ProcessMessages;
        end;
      sFile.Free;
    end;
  Label7.Caption := 'Estado: Listo...';
  if (cant>1) and (Edit2.Text='') then
    Button2.Enabled := True;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  reg: TRegistry;
begin
  reg:=TRegistry.Create;
  reg.RootKey:=HKEY_LOCAL_MACHINE;
  reg.OpenKey('SOFTWARE\Buscador',True);
  reg.WriteString('patron', Edit3.Text);
  if CheckBox1.Checked then
    reg.WriteString('subdirs', 'Si')
  else
    reg.WriteString('subdirs', 'No');
  reg.Free;
  fList.Free;
  dList.Free;
end;

function TForm1.lDir(dOrigen: string) : String;
var
  sr: TSearchRec;
begin
  Application.ProcessMessages;
  chDir (dOrigen);
  FindFirst ('*.*', faDirectory, sr);
  while FindNext(sr)=0 do
    begin
      if (sr.Attr = faDirectory) then
        if (sr.Name<>'..') and (sr.Name<>'.') and (CheckBox1.Checked) then
          lDir(dOrigen+sr.Name+'\')
        else
          dList.Add(dOrigen)
   end;
  FindClose(sr);
  Label4.Caption := 'Carpetas en la ruta: '+IntToStr(dList.Count-1);
end;

function TForm1.lFile(dOrigen: string) : String;
var
  sr: TSearchRec;
begin
  Application.ProcessMessages;
  chDir (dOrigen);
  FindFirst (Edit3.Text, faAnyFile, sr);
  while FindNext(sr)=0 do
    begin
      if (sr.Attr = faDirectory) then
        begin
          if (sr.Name<>'..') and (sr.Name<>'.') and (CheckBox1.Checked) then
            lFile(dOrigen+sr.Name+'\')
        end
      else
        fList.Add(dOrigen+sr.Name)
   end;
  FindClose(sr);
  Label5.Caption := 'Ficheros en la ruta: '+IntToStr(fList.Count+1);
end;

function TForm1.fInFile(const Fichero: string ;const Cadena: string):integer;
const
  CUANTOBUFFER = 32768; //32768->32 Kb, 8192->8 Kb;
var
  Corriente  : TFileStream;
  Almacen    : String;
  Donde      : integer;
  Parar      : boolean;
  Posicion   : integer;
begin
  SetLength(Almacen, CUANTOBUFFER);
  Corriente:=TFileStream.Create(Fichero,fmOpenRead OR fmShareDenyWrite);
  Result:=-1;
  try
    Corriente.Seek(0,soFromBeginning);
    Parar:=FALSE;
    repeat
      Posicion:=Corriente.Position;
      Parar:= ( Corriente.Read(Almacen[1],CUANTOBUFFER) < CUANTOBUFFER );
      Donde:=Pos(Cadena, Almacen);

      If Donde <> 0 then begin
        Result:=Donde+Posicion;
        Parar:=TRUE;
      end else begin
        Corriente.Seek(Length(Cadena),soFromCurrent);
      end;
    until Parar;
  finally
    Corriente.Free;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  ListBox1.Clear;
  Memo1.Clear;
  ListBox1.Items.AddStrings(fChange);
  GroupBox3.Visible := True;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
var
  SelPos: Integer;
  x: Integer;
begin
  sFile := TCustomMemo.Create(Self);
    with sFile do
      begin
        Name := 'sFile';
        Parent := Self;
        Lines.Clear;
      end;
  sFile.Lines.LoadFromFile(ListBox1.Items.Strings[ListBox1.ItemIndex]);
  Memo1.Clear;
  For x:=0 to sFile.Lines.Count-1 do
    begin
      SelPos := Pos(Edit1.Text, sFile.Lines.Strings[x]);
      if SelPos > 0 then
        Memo1.Lines.Append(IntToStr(x)+' -> '+sFile.Lines.Strings[x]);
      end;
  sFile.Clear;
  sFile.Free;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  GroupBox3.Visible := False;
end;

end.
